.build-push-and-tag-image:
  image: docker:20.10.18
  stage: deploy
  tags:
    - privileged
  interruptible: true
  rules:
    - if: '$GITLAB_INTERNAL && $CI_COMMIT_REF_NAME == $INTERNAL_REF_BRANCH'
    - if: '$GITLAB_INTERNAL && $CI_COMMIT_TAG'
    - if: '$GITLAB_INTERNAL && $CI_COMMIT_REF_PROTECTED == "true"'
  services:
    - docker:20.10.18-dind
  retry:
    max: 2
    when:
      - runner_system_failure
      - api_failure
      - scheduler_failure
  script:
    - printenv
    - for i in $(seq 1 5); do docker info && break || sleep 5; done
    - |
      REGISTRY_URLS=$(env | grep REGISTRY_URL_)
      for item in $REGISTRY_URLS; do
        REGISTRY_URL=$(echo $item | rev | cut -d'=' -f1 | rev)
        SUFFIX=$(echo ${item//REGISTRY_URL_} | rev | cut -d'=' -f2 | rev)
        REGISTRY_USER=$(env | grep REGISTRY_USER_$SUFFIX= | rev | cut -d'=' -f1 | rev)
        REGISTRY_PASSWORD=$(env | grep REGISTRY_PASSWORD_$SUFFIX= | rev | cut -d'=' -f1 | rev)
        docker login -u $REGISTRY_USER -p $REGISTRY_PASSWORD $REGISTRY_URL
      done
    - docker build --network host --no-cache -t $IMAGE_BASE:latest .
    - |
      if [[ "$CI_COMMIT_REF_NAME" == "$INTERNAL_REF_BRANCH" ]]; then
        exit 0
      fi
    - |
      if [[ "$CI_COMMIT_REF_SLUG" == "main" ]]; then
        echo "push image $IMAGE_BASE:latest"
        docker push $IMAGE_BASE:latest
      fi
    - |
      if [ -n "$CI_COMMIT_TAG" ]; then
        docker tag $IMAGE_BASE:latest $IMAGE_BASE:$CI_COMMIT_TAG
        echo "push image $IMAGE_BASE:$CI_COMMIT_TAG"
        docker push $IMAGE_BASE:$CI_COMMIT_TAG
      fi
